
// 2004-11-11 [10:26]
//  *. New Version 

public class BaseNMatrix {
// 	public static final boolean DEBUG = true;
	private int nElements;
	private int bin_string_length;
	private int limit;
	private long a;

// 2004-11-11 [07:49]
//  **. getPossibleValues 

/* 
Returns something like:

{
"0	0	0",
"0	0	1",
"0	1	0",
"0	1	1",
"1	0	0",
"1	0	1",
"1	1	0",
"1	1	1"
}
 */

	public String[] getPossibleValues(int nTruthValues /* radix */, int size) {

// 2004-11-11 [18:35]
//  ***. check the state 

		/* presupposition: nElements > 0 */
		if(size <= 0) {
			System.out.println("BaseNMatrix.class:getPossibleValues() : size must be bigger than 0." );
			System.out.println( "Returning null..."  );
			return null;
		}
		else if ( nTruthValues > 10) {
			System.out.println( "WARNING: Maximum number of truth values is 10. "  );
			System.out.println( "Returning null..."  );
			return null;
		}
		else nElements = size;

		limit = (int) Math.pow( nTruthValues, nElements );
		/* Long.MAX_VALUE is 2^63 - 1 */
		if( limit > Long.MAX_VALUE ) {		// long can be 0 ~ (2^63 - 1). Thus, we set the maximum `limit' to be  2^63. If over the value, return null.
// 		if( limit > (Long.MAX_VALUE + 1) ) {		// This is actually  the corret value, but this gives an error, causing the program to terminate abnormally.
			System.out.println( "The table is too big to handle..."  );
			System.out.println( "The maximum number of table elements is 2^63."  );
			System.out.println( "Returning null..."  );
			return null;
		}


// 2004-11-11 [18:35]
//  ***. make table 

		String[] rows = new String[limit];

		a = 0x0;

		for(int i = 0; i < limit; i++) {
			rows[i]  = Long.toString( a, nTruthValues );
			bin_string_length = rows[i].length();

			// ex: "1 0 1", "1 0 0 1 0" 
			String tmp = rows[i];
			rows[i] = "" ;
			for ( int j = 0 ; j < tmp.length() ; j++ ) {
				rows[i] = rows[i] + tmp.substring(j, j + 1) + "\t" ;
			}		// end of for loop
			rows[i] = rows[i].trim();
			/* I WISH JAVA REGEXP WORKED THE WAY ELISP AND PERL REGEXP WORK. JAVA'S IS SO STUPID, TO BE HONEST.  */
// 			rows[i] = rows[i].replaceAll( "[0-9]" , "	\\1	" ).trim();

			for( int j = nElements ;  j > bin_string_length; j-- ) {
				rows[i] = "0	"  +  rows[i] ;		// !! append missing part
			}

			a += 0x1;
		}

		return rows;
	}
		
// bsh % print( Integer.toString( 1 , 2 ) ); 
// 1	--> 0	0	0	1
// bsh % print( Integer.toString( 2 , 2 ) ); 
// 10	--> 0	0	1	0
// bsh % print( Integer.toString( 7 , 2 ) ); 
// 111	--> 0	1	1	1
// bsh % print( Integer.toString( 15 , 2 ) ); 
// 1111 --> 1	1	1	1


// 000
// 001
// 010
// 011
// 100
// 101
// 110
// 111

// 1   1   1   1
// 1   1   1   0
// 1   1   0   1
// 1   1   0   0
// 1   0   1   1
// 1   0   1   0
// 1   0   0   1
// 1   0   0   0
// 0   1   1   1
// 0   1   1   0
// 0   1   0   1
// 0   1   0   0
// 0   0   1   1
// 0   0   1   0
// 0   0   0   1
// 0   0   0   0


	public static void main(String[] args) {

//  **. truth value: 2, sentence symbol: 2 
// 2004-11-08 [23:55]

		int nElements = 2;
		int nTruthValues = 2;
		int limit = (int) Math.pow( nTruthValues, nElements );

		String[] possibilities = new String[ limit ];

		BaseNMatrix matrix = new BaseNMatrix();
		possibilities = matrix.getPossibleValues(nTruthValues, nElements);

		System.out.println( "Inside possibilities[][] with two sentence symbols given..."  );

		for( int i = 0 ; i < limit; i++ ) {
			System.out.print(possibilities[i]);
			System.out.println(  );
		}

// Inside possibilities[][] with two sentence symbols given...
// 00
// 01
// 10
// 11


//  **. truth value: 2, sentence symbol: 3
// 2004-11-08 [23:55]


		System.out.println(  );
		System.out.println(  );

		nElements = 3;
		limit =  (int) Math.pow( nTruthValues, nElements );
		String[] possibilities2 = new String[ limit ];
		possibilities2 = matrix.getPossibleValues( nTruthValues, nElements );

		System.out.println( "Inside possibilities[][] with three sentence symbols given..."  );

		for( int i = 0 ; i < limit; i++ ) {
				System.out.print(possibilities2[i]);
				System.out.println(  );
		}

// Inside possibilities[][] with three sentence symbols given...
// 000
// 001
// 010
// 011
// 100
// 101
// 110
// 111

//  **. truth value: 3, sentence symbol: 3
// 2004-11-08 [23:55]

		System.out.println(  );
		System.out.println(  );

		nElements = 3;
		nTruthValues = 3;
		limit =  (int) Math.pow( nTruthValues, nElements );
		String[] possibilities3 = new String[ limit ];
		possibilities3 = matrix.getPossibleValues( nTruthValues, nElements );

		System.out.println( "Inside possibilities[][] with three sentence symbols and with three truth values given..."  );

		for( int i = 0 ; i < limit; i++ ) {
				System.out.print(possibilities3[i]);
			System.out.println(  );
		}

// Inside possibilities[][] with three sentence symbols and with three truth values given...
// 000
// 001
// 002
// 010
// 011
// 012
// 020
// 021
// 022
// 100
// 101
// 102
// 110
// 111
// 112
// 120
// 121
// 122
// 200
// 201
// 202
// 210
// 211
// 212
// 220
// 221
// 222


//  **. truth value: 5, sentence symbol: 4
// 2004-11-08 [23:55]

		System.out.println(  );
		System.out.println(  );

		nElements = 4;
		nTruthValues = 8;
		limit =  (int) Math.pow( nTruthValues, nElements );
		String[] possibilities4 = new String[ limit ];
		possibilities4 = matrix.getPossibleValues( nTruthValues, nElements );

		System.out.println( "Inside possibilities[][] with three sentence symbols and with three truth values given..."  );

		for( int i = 0 ; i < limit; i++ ) {
				System.out.print(possibilities4[i]);
			System.out.println(  );
		}


// 		java.math.BigInteger bi1 = new java.math.BigInteger( "1" );
// 		System.out.println( bi1.toString() );



	} // end of main()

}		// end of class `BaseNMatrix'

// -----------------------------------------------------------------------------

	




// /**
//  * Last modified: 2004-11-11 [19:17]12 21 2003
//  *
//  * @author Takayuki Hoshi <hoshi103@chapman.edu>
//  * File: BaseNMatrix.java
//  * 
//  * Here in this class, we will cheat --- BIG TIME, by already defining the BitN
//  * table for some possible cases.
//  */

// public class BaseNMatrix {
// // 	public static final boolean DEBUG = true;
// 	private int nElements;
// 	private String bin_string;
// 	private int bin_string_length;
// 	private int limit;
// 	private String[][] elements;
// 	private byte a;
	
	
	
// // 2004-11-11 [07:49]
// //  **. getPossibleValues 
	
// /*
//  * Here in this class, we will cheat --- BIG TIME, by already defining the BitN
//  * table for some possible cases.
//  */
// 	public String[][] getPossibleValues(int nTruthValues /* radix */, int size) {
		
// 		/* presupposition: nElements > 0 */
// 		if(size <= 0) {
// 			System.out.println("BaseNMatrix.class:getPossibleValues() : size must be bigger than 0." );
// 			System.out.println( "Returning null..."  );
// 			return null;
// 		} else nElements = size;
		
// 	}




	
	
// 	public String[][] getPossibleValuesReversed ( int nTruthValues, int size ) {
// // 		String[][] possibilities = { { "0" , "0" }, { "0" , "1" } , { "1" , "0" }, { "1" , "1" } };
// // 00
// // 01
// // 10
// // 11
		
// 		/* call accordingly */
		
// 	}
	
	
// /*
//  *	( Number of Truth Values )^( Number of Symbols )  x ( Number of Symbols )
//  */
	

// public String[][] TV2_S1() {

// String[][] possibilities = {
// { "1" ,  } , 
// { "0" ,  } 
// } ;

// return possibilities;
// }
	
	
// 	// TV: 2, S: 2
// 	public String[][] TV2_S2() {
		
// 		String[][] possibilities = { 
// 			{ "1" , "1" } ,
// 			{ "1" , "0" }, 
// 			{ "0" , "1" } , 
// 			{ "0" , "0" }, 
// 		} ;
		
// 		return possibilities;
		
// 	}
	
// 	public String[][] TV2_S3 () {
		
// 		String[][] possibilities = {
// 			{ "1",   "1",   "1"} ,
// 			{ "1",   "1",   "0"} ,		
// 			{ "1",   "0",   "1"} ,		
// 			{ "1",   "0",   "0"} ,		
// 			{ "0",   "1",   "1"} ,		
// 			{ "0",   "1",   "0"} ,		
// 			{ "0",   "0",   "1"} ,		
// 			{ "0",   "0",   "0"}
// 		};
		
// 		return possibilities;
// 	}
	
// 	public String[][] TV2_S4 () {
		
		
// 		String[][]
// 			possibilities = {
// 			{ "1" , 	"1" , 	"1" , 	"1"  } , 
// 			{ "1" , 	"1" , 	"1" , 	"0"  } , 
// 			{ "1" , 	"1" , 	"0" , 	"1"  } , 
// 			{ "1" , 	"1" , 	"0" , 	"0"  } , 
// 			{ "1" , 	"0" , 	"1" , 	"1"  } , 
// 			{ "1" , 	"0" , 	"1" , 	"0"  } , 
// 			{ "1" , 	"0" , 	"0" , 	"1"  } , 
// 			{ "1" , 	"0" , 	"0" , 	"0"  } , 
// 			{ "0" , 	"1" , 	"1" , 	"1"  } , 
// 			{ "0" , 	"1" , 	"1" , 	"0"  } , 
// 			{ "0" , 	"1" , 	"0" , 	"1"  } , 
// 			{ "0" , 	"1" , 	"0" , 	"0"  } , 
// 			{ "0" , 	"0" , 	"1" , 	"1"  } , 
// 			{ "0" , 	"0" , 	"1" , 	"0"  } , 		
// 			{ "0" , 	"0" , 	"0" , 	"1"  } , 		
// 			{ "0" , 	"0" , 	"0" , 	"0"  } 
// 		};
		
// 		return possibilities;
		
// 	}
	
	
	
// 	public String[][]	TV2_S5() {
		
// 		String[][]
// 			possibilities = {
// 			{ "1" ,	"1" ,	"1" ,	"1" ,	"1" ,  } , 
// 			{ "1" ,	"1" ,	"1" ,	"1" ,	"0" ,  } , 
// 			{ "1" ,	"1" ,	"1" ,	"0" ,	"1" ,  } , 
// 			{ "1" ,	"1" ,	"1" ,	"0" ,	"0" ,  } , 
// 			{ "1" ,	"1" ,	"0" ,	"1" ,	"1" ,  } , 
// 			{ "1" ,	"1" ,	"0" ,	"1" ,	"0" ,  } , 
// 			{ "1" ,	"1" ,	"0" ,	"0" ,	"1" ,  } , 
// 			{ "1" ,	"1" ,	"0" ,	"0" ,	"0" ,  } , 
// 			{ "1" ,	"0" ,	"1" ,	"1" ,	"1" ,  } , 
// 			{ "1" ,	"0" ,	"1" ,	"1" ,	"0" ,  } , 
// 			{ "1" ,	"0" ,	"1" ,	"0" ,	"1" ,  } , 
// 			{ "1" ,	"0" ,	"1" ,	"0" ,	"0" ,  } , 
// 			{ "1" ,	"0" ,	"0" ,	"1" ,	"1" ,  } , 
// 			{ "1" ,	"0" ,	"0" ,	"1" ,	"0" ,  } , 
// 			{ "1" ,	"0" ,	"0" ,	"0" ,	"1" ,  } , 
// 			{ "1" ,	"0" ,	"0" ,	"0" ,	"0" ,  } , 
// 			{ "0" ,	"1" ,	"1" ,	"1" ,	"1" ,  } , 
// 			{ "0" ,	"1" ,	"1" ,	"1" ,	"0" ,  } , 
// 			{ "0" ,	"1" ,	"1" ,	"0" ,	"1" ,  } , 
// 			{ "0" ,	"1" ,	"1" ,	"0" ,	"0" ,  } , 
// 			{ "0" ,	"1" ,	"0" ,	"1" ,	"1" ,  } , 
// 			{ "0" ,	"1" ,	"0" ,	"1" ,	"0" ,  } , 
// 			{ "0" ,	"1" ,	"0" ,	"0" ,	"1" ,  } , 
// 			{ "0" ,	"1" ,	"0" ,	"0" ,	"0" ,  } , 
// 			{ "0" ,	"0" ,	"1" ,	"1" ,	"1" ,  } , 
// 			{ "0" ,	"0" ,	"1" ,	"1" ,	"0" ,  } , 
// 			{ "0" ,	"0" ,	"1" ,	"0" ,	"1" ,  } , 
// 			{ "0" ,	"0" ,	"1" ,	"0" ,	"0" ,  } , 
// 			{ "0" ,	"0" ,	"0" ,	"1" ,	"1" ,  } , 
// 			{ "0" ,	"0" ,	"0" ,	"1" ,	"0" ,  } , 
// 			{ "0" ,	"0" ,	"0" ,	"0" ,	"1" ,  } , 
// 			{ "0" ,	"0" ,	"0" ,	"0" ,	"0" ,  } 
// 		};
		
// 		return possibilities;
		
// 	} 
	
	
	
// 	public String[][]	TV2_S6() {
		
// 		String[][] possibilities = {
// 			{ "1" ,	"1" ,	"1" ,	"1" ,	"1" ,	"1" ,  } , 
// 			{ "1" ,	"1" ,	"1" ,	"1" ,	"1" ,	"0" ,  } , 
// 			{ "1" ,	"1" ,	"1" ,	"1" ,	"0" ,	"1" ,  } , 
// 			{ "1" ,	"1" ,	"1" ,	"1" ,	"0" ,	"0" ,  } , 
// 			{ "1" ,	"1" ,	"1" ,	"0" ,	"1" ,	"1" ,  } , 
// 			{ "1" ,	"1" ,	"1" ,	"0" ,	"1" ,	"0" ,  } , 
// 			{ "1" ,	"1" ,	"1" ,	"0" ,	"0" ,	"1" ,  } , 
// 			{ "1" ,	"1" ,	"1" ,	"0" ,	"0" ,	"0" ,  } , 
// 			{ "1" ,	"1" ,	"0" ,	"1" ,	"1" ,	"1" ,  } , 
// 			{ "1" ,	"1" ,	"0" ,	"1" ,	"1" ,	"0" ,  } , 
// 			{ "1" ,	"1" ,	"0" ,	"1" ,	"0" ,	"1" ,  } , 
// 			{ "1" ,	"1" ,	"0" ,	"1" ,	"0" ,	"0" ,  } , 
// 			{ "1" ,	"1" ,	"0" ,	"0" ,	"1" ,	"1" ,  } , 
// 			{ "1" ,	"1" ,	"0" ,	"0" ,	"1" ,	"0" ,  } , 
// 			{ "1" ,	"1" ,	"0" ,	"0" ,	"0" ,	"1" ,  } , 
// 			{ "1" ,	"1" ,	"0" ,	"0" ,	"0" ,	"0" ,  } , 
// 			{ "1" ,	"0" ,	"1" ,	"1" ,	"1" ,	"1" ,  } , 
// 			{ "1" ,	"0" ,	"1" ,	"1" ,	"1" ,	"0" ,  } , 
// 			{ "1" ,	"0" ,	"1" ,	"1" ,	"0" ,	"1" ,  } , 
// 			{ "1" ,	"0" ,	"1" ,	"1" ,	"0" ,	"0" ,  } , 
// 			{ "1" ,	"0" ,	"1" ,	"0" ,	"1" ,	"1" ,  } , 
// 			{ "1" ,	"0" ,	"1" ,	"0" ,	"1" ,	"0" ,  } , 
// 			{ "1" ,	"0" ,	"1" ,	"0" ,	"0" ,	"1" ,  } , 
// 			{ "1" ,	"0" ,	"1" ,	"0" ,	"0" ,	"0" ,  } , 
// 			{ "1" ,	"0" ,	"0" ,	"1" ,	"1" ,	"1" ,  } , 
// 			{ "1" ,	"0" ,	"0" ,	"1" ,	"1" ,	"0" ,  } , 
// 			{ "1" ,	"0" ,	"0" ,	"1" ,	"0" ,	"1" ,  } , 
// 			{ "1" ,	"0" ,	"0" ,	"1" ,	"0" ,	"0" ,  } , 
// 			{ "1" ,	"0" ,	"0" ,	"0" ,	"1" ,	"1" ,  } , 
// 			{ "1" ,	"0" ,	"0" ,	"0" ,	"1" ,	"0" ,  } , 
// 			{ "1" ,	"0" ,	"0" ,	"0" ,	"0" ,	"1" ,  } , 
// 			{ "1" ,	"0" ,	"0" ,	"0" ,	"0" ,	"0" ,  } , 
// 			{ "0" ,	"1" ,	"1" ,	"1" ,	"1" ,	"1" ,  } , 
// 			{ "0" ,	"1" ,	"1" ,	"1" ,	"1" ,	"0" ,  } , 
// 			{ "0" ,	"1" ,	"1" ,	"1" ,	"0" ,	"1" ,  } , 
// 			{ "0" ,	"1" ,	"1" ,	"1" ,	"0" ,	"0" ,  } , 
// 			{ "0" ,	"1" ,	"1" ,	"0" ,	"1" ,	"1" ,  } , 
// 			{ "0" ,	"1" ,	"1" ,	"0" ,	"1" ,	"0" ,  } , 
// 			{ "0" ,	"1" ,	"1" ,	"0" ,	"0" ,	"1" ,  } , 
// 			{ "0" ,	"1" ,	"1" ,	"0" ,	"0" ,	"0" ,  } , 
// 			{ "0" ,	"1" ,	"0" ,	"1" ,	"1" ,	"1" ,  } , 
// 			{ "0" ,	"1" ,	"0" ,	"1" ,	"1" ,	"0" ,  } , 
// 			{ "0" ,	"1" ,	"0" ,	"1" ,	"0" ,	"1" ,  } , 
// 			{ "0" ,	"1" ,	"0" ,	"1" ,	"0" ,	"0" ,  } , 
// 			{ "0" ,	"1" ,	"0" ,	"0" ,	"1" ,	"1" ,  } , 
// 			{ "0" ,	"1" ,	"0" ,	"0" ,	"1" ,	"0" ,  } , 
// 			{ "0" ,	"1" ,	"0" ,	"0" ,	"0" ,	"1" ,  } , 
// 			{ "0" ,	"1" ,	"0" ,	"0" ,	"0" ,	"0" ,  } , 
// 			{ "0" ,	"0" ,	"1" ,	"1" ,	"1" ,	"1" ,  } , 
// 			{ "0" ,	"0" ,	"1" ,	"1" ,	"1" ,	"0" ,  } , 
// 			{ "0" ,	"0" ,	"1" ,	"1" ,	"0" ,	"1" ,  } , 
// 			{ "0" ,	"0" ,	"1" ,	"1" ,	"0" ,	"0" ,  } , 
// 			{ "0" ,	"0" ,	"1" ,	"0" ,	"1" ,	"1" ,  } , 
// 			{ "0" ,	"0" ,	"1" ,	"0" ,	"1" ,	"0" ,  } , 
// 			{ "0" ,	"0" ,	"1" ,	"0" ,	"0" ,	"1" ,  } , 
// 			{ "0" ,	"0" ,	"1" ,	"0" ,	"0" ,	"0" ,  } , 
// 			{ "0" ,	"0" ,	"0" ,	"1" ,	"1" ,	"1" ,  } , 
// 			{ "0" ,	"0" ,	"0" ,	"1" ,	"1" ,	"0" ,  } , 
// 			{ "0" ,	"0" ,	"0" ,	"1" ,	"0" ,	"1" ,  } , 
// 			{ "0" ,	"0" ,	"0" ,	"1" ,	"0" ,	"0" ,  } , 
// 			{ "0" ,	"0" ,	"0" ,	"0" ,	"1" ,	"1" ,  } , 
// 			{ "0" ,	"0" ,	"0" ,	"0" ,	"1" ,	"0" ,  } , 
// 			{ "0" ,	"0" ,	"0" ,	"0" ,	"0" ,	"1" ,  } , 
// 			{ "0" ,	"0" ,	"0" ,	"0" ,	"0" ,	"0" ,  } 
// 		} ;
		
// 		return possibilities;
		
// 	}
	
// public String[][] TV2_S7 () {

// String[][] possibilities = {
// { "1" ,    "1" ,    "1" ,    "1" ,    "1" ,    "1" ,    "1" ,  } , 
// { "1" ,    "1" ,    "1" ,    "1" ,    "1" ,    "1" ,    "0" ,  } , 
// { "1" ,    "1" ,    "1" ,    "1" ,    "1" ,    "0" ,    "1" ,  } , 
// { "1" ,    "1" ,    "1" ,    "1" ,    "1" ,    "0" ,    "0" ,  } , 
// { "1" ,    "1" ,    "1" ,    "1" ,    "0" ,    "1" ,    "1" ,  } , 
// { "1" ,    "1" ,    "1" ,    "1" ,    "0" ,    "1" ,    "0" ,  } , 
// { "1" ,    "1" ,    "1" ,    "1" ,    "0" ,    "0" ,    "1" ,  } , 
// { "1" ,    "1" ,    "1" ,    "1" ,    "0" ,    "0" ,    "0" ,  } , 
// { "1" ,    "1" ,    "1" ,    "0" ,    "1" ,    "1" ,    "1" ,  } , 
// { "1" ,    "1" ,    "1" ,    "0" ,    "1" ,    "1" ,    "0" ,  } , 
// { "1" ,    "1" ,    "1" ,    "0" ,    "1" ,    "0" ,    "1" ,  } , 
// { "1" ,    "1" ,    "1" ,    "0" ,    "1" ,    "0" ,    "0" ,  } , 
// { "1" ,    "1" ,    "1" ,    "0" ,    "0" ,    "1" ,    "1" ,  } , 
// { "1" ,    "1" ,    "1" ,    "0" ,    "0" ,    "1" ,    "0" ,  } , 
// { "1" ,    "1" ,    "1" ,    "0" ,    "0" ,    "0" ,    "1" ,  } , 
// { "1" ,    "1" ,    "1" ,    "0" ,    "0" ,    "0" ,    "0" ,  } , 
// { "1" ,    "1" ,    "0" ,    "1" ,    "1" ,    "1" ,    "1" ,  } , 
// { "1" ,    "1" ,    "0" ,    "1" ,    "1" ,    "1" ,    "0" ,  } , 
// { "1" ,    "1" ,    "0" ,    "1" ,    "1" ,    "0" ,    "1" ,  } , 
// { "1" ,    "1" ,    "0" ,    "1" ,    "1" ,    "0" ,    "0" ,  } , 
// { "1" ,    "1" ,    "0" ,    "1" ,    "0" ,    "1" ,    "1" ,  } , 
// { "1" ,    "1" ,    "0" ,    "1" ,    "0" ,    "1" ,    "0" ,  } , 
// { "1" ,    "1" ,    "0" ,    "1" ,    "0" ,    "0" ,    "1" ,  } , 
// { "1" ,    "1" ,    "0" ,    "1" ,    "0" ,    "0" ,    "0" ,  } , 
// { "1" ,    "1" ,    "0" ,    "0" ,    "1" ,    "1" ,    "1" ,  } , 
// { "1" ,    "1" ,    "0" ,    "0" ,    "1" ,    "1" ,    "0" ,  } , 
// { "1" ,    "1" ,    "0" ,    "0" ,    "1" ,    "0" ,    "1" ,  } , 
// { "1" ,    "1" ,    "0" ,    "0" ,    "1" ,    "0" ,    "0" ,  } , 
// { "1" ,    "1" ,    "0" ,    "0" ,    "0" ,    "1" ,    "1" ,  } , 
// { "1" ,    "1" ,    "0" ,    "0" ,    "0" ,    "1" ,    "0" ,  } , 
// { "1" ,    "1" ,    "0" ,    "0" ,    "0" ,    "0" ,    "1" ,  } , 
// { "1" ,    "1" ,    "0" ,    "0" ,    "0" ,    "0" ,    "0" ,  } , 
// { "1" ,    "0" ,    "1" ,    "1" ,    "1" ,    "1" ,    "1" ,  } , 
// { "1" ,    "0" ,    "1" ,    "1" ,    "1" ,    "1" ,    "0" ,  } , 
// { "1" ,    "0" ,    "1" ,    "1" ,    "1" ,    "0" ,    "1" ,  } , 
// { "1" ,    "0" ,    "1" ,    "1" ,    "1" ,    "0" ,    "0" ,  } , 
// { "1" ,    "0" ,    "1" ,    "1" ,    "0" ,    "1" ,    "1" ,  } , 
// { "1" ,    "0" ,    "1" ,    "1" ,    "0" ,    "1" ,    "0" ,  } , 
// { "1" ,    "0" ,    "1" ,    "1" ,    "0" ,    "0" ,    "1" ,  } , 
// { "1" ,    "0" ,    "1" ,    "1" ,    "0" ,    "0" ,    "0" ,  } , 
// { "1" ,    "0" ,    "1" ,    "0" ,    "1" ,    "1" ,    "1" ,  } , 
// { "1" ,    "0" ,    "1" ,    "0" ,    "1" ,    "1" ,    "0" ,  } , 
// { "1" ,    "0" ,    "1" ,    "0" ,    "1" ,    "0" ,    "1" ,  } , 
// { "1" ,    "0" ,    "1" ,    "0" ,    "1" ,    "0" ,    "0" ,  } , 
// { "1" ,    "0" ,    "1" ,    "0" ,    "0" ,    "1" ,    "1" ,  } , 
// { "1" ,    "0" ,    "1" ,    "0" ,    "0" ,    "1" ,    "0" ,  } , 
// { "1" ,    "0" ,    "1" ,    "0" ,    "0" ,    "0" ,    "1" ,  } , 
// { "1" ,    "0" ,    "1" ,    "0" ,    "0" ,    "0" ,    "0" ,  } , 
// { "1" ,    "0" ,    "0" ,    "1" ,    "1" ,    "1" ,    "1" ,  } , 
// { "1" ,    "0" ,    "0" ,    "1" ,    "1" ,    "1" ,    "0" ,  } , 
// { "1" ,    "0" ,    "0" ,    "1" ,    "1" ,    "0" ,    "1" ,  } , 
// { "1" ,    "0" ,    "0" ,    "1" ,    "1" ,    "0" ,    "0" ,  } , 
// { "1" ,    "0" ,    "0" ,    "1" ,    "0" ,    "1" ,    "1" ,  } , 
// { "1" ,    "0" ,    "0" ,    "1" ,    "0" ,    "1" ,    "0" ,  } , 
// { "1" ,    "0" ,    "0" ,    "1" ,    "0" ,    "0" ,    "1" ,  } , 
// { "1" ,    "0" ,    "0" ,    "1" ,    "0" ,    "0" ,    "0" ,  } , 
// { "1" ,    "0" ,    "0" ,    "0" ,    "1" ,    "1" ,    "1" ,  } , 
// { "1" ,    "0" ,    "0" ,    "0" ,    "1" ,    "1" ,    "0" ,  } , 
// { "1" ,    "0" ,    "0" ,    "0" ,    "1" ,    "0" ,    "1" ,  } , 
// { "1" ,    "0" ,    "0" ,    "0" ,    "1" ,    "0" ,    "0" ,  } , 
// { "1" ,    "0" ,    "0" ,    "0" ,    "0" ,    "1" ,    "1" ,  } , 
// { "1" ,    "0" ,    "0" ,    "0" ,    "0" ,    "1" ,    "0" ,  } , 
// { "1" ,    "0" ,    "0" ,    "0" ,    "0" ,    "0" ,    "1" ,  } , 
// { "1" ,    "0" ,    "0" ,    "0" ,    "0" ,    "0" ,    "0" ,  } , 
// { "0" ,    "1" ,    "1" ,    "1" ,    "1" ,    "1" ,    "1" ,  } , 
// { "0" ,    "1" ,    "1" ,    "1" ,    "1" ,    "1" ,    "0" ,  } , 
// { "0" ,    "1" ,    "1" ,    "1" ,    "1" ,    "0" ,    "1" ,  } , 
// { "0" ,    "1" ,    "1" ,    "1" ,    "1" ,    "0" ,    "0" ,  } , 
// { "0" ,    "1" ,    "1" ,    "1" ,    "0" ,    "1" ,    "1" ,  } , 
// { "0" ,    "1" ,    "1" ,    "1" ,    "0" ,    "1" ,    "0" ,  } , 
// { "0" ,    "1" ,    "1" ,    "1" ,    "0" ,    "0" ,    "1" ,  } , 
// { "0" ,    "1" ,    "1" ,    "1" ,    "0" ,    "0" ,    "0" ,  } , 
// { "0" ,    "1" ,    "1" ,    "0" ,    "1" ,    "1" ,    "1" ,  } , 
// { "0" ,    "1" ,    "1" ,    "0" ,    "1" ,    "1" ,    "0" ,  } , 
// { "0" ,    "1" ,    "1" ,    "0" ,    "1" ,    "0" ,    "1" ,  } , 
// { "0" ,    "1" ,    "1" ,    "0" ,    "1" ,    "0" ,    "0" ,  } , 
// { "0" ,    "1" ,    "1" ,    "0" ,    "0" ,    "1" ,    "1" ,  } , 
// { "0" ,    "1" ,    "1" ,    "0" ,    "0" ,    "1" ,    "0" ,  } , 
// { "0" ,    "1" ,    "1" ,    "0" ,    "0" ,    "0" ,    "1" ,  } , 
// { "0" ,    "1" ,    "1" ,    "0" ,    "0" ,    "0" ,    "0" ,  } , 
// { "0" ,    "1" ,    "0" ,    "1" ,    "1" ,    "1" ,    "1" ,  } , 
// { "0" ,    "1" ,    "0" ,    "1" ,    "1" ,    "1" ,    "0" ,  } , 
// { "0" ,    "1" ,    "0" ,    "1" ,    "1" ,    "0" ,    "1" ,  } , 
// { "0" ,    "1" ,    "0" ,    "1" ,    "1" ,    "0" ,    "0" ,  } , 
// { "0" ,    "1" ,    "0" ,    "1" ,    "0" ,    "1" ,    "1" ,  } , 
// { "0" ,    "1" ,    "0" ,    "1" ,    "0" ,    "1" ,    "0" ,  } , 
// { "0" ,    "1" ,    "0" ,    "1" ,    "0" ,    "0" ,    "1" ,  } , 
// { "0" ,    "1" ,    "0" ,    "1" ,    "0" ,    "0" ,    "0" ,  } , 
// { "0" ,    "1" ,    "0" ,    "0" ,    "1" ,    "1" ,    "1" ,  } , 
// { "0" ,    "1" ,    "0" ,    "0" ,    "1" ,    "1" ,    "0" ,  } , 
// { "0" ,    "1" ,    "0" ,    "0" ,    "1" ,    "0" ,    "1" ,  } , 
// { "0" ,    "1" ,    "0" ,    "0" ,    "1" ,    "0" ,    "0" ,  } , 
// { "0" ,    "1" ,    "0" ,    "0" ,    "0" ,    "1" ,    "1" ,  } , 
// { "0" ,    "1" ,    "0" ,    "0" ,    "0" ,    "1" ,    "0" ,  } , 
// { "0" ,    "1" ,    "0" ,    "0" ,    "0" ,    "0" ,    "1" ,  } , 
// { "0" ,    "1" ,    "0" ,    "0" ,    "0" ,    "0" ,    "0" ,  } , 
// { "0" ,    "0" ,    "1" ,    "1" ,    "1" ,    "1" ,    "1" ,  } , 
// { "0" ,    "0" ,    "1" ,    "1" ,    "1" ,    "1" ,    "0" ,  } , 
// { "0" ,    "0" ,    "1" ,    "1" ,    "1" ,    "0" ,    "1" ,  } , 
// { "0" ,    "0" ,    "1" ,    "1" ,    "1" ,    "0" ,    "0" ,  } , 
// { "0" ,    "0" ,    "1" ,    "1" ,    "0" ,    "1" ,    "1" ,  } , 
// { "0" ,    "0" ,    "1" ,    "1" ,    "0" ,    "1" ,    "0" ,  } , 
// { "0" ,    "0" ,    "1" ,    "1" ,    "0" ,    "0" ,    "1" ,  } , 
// { "0" ,    "0" ,    "1" ,    "1" ,    "0" ,    "0" ,    "0" ,  } , 	
// { "0" ,    "0" ,    "1" ,    "0" ,    "1" ,    "1" ,    "1" ,  } , 	
// { "0" ,    "0" ,    "1" ,    "0" ,    "1" ,    "1" ,    "0" ,  } , 
// { "0" ,    "0" ,    "1" ,    "0" ,    "1" ,    "0" ,    "1" ,  } , 
// { "0" ,    "0" ,    "1" ,    "0" ,    "1" ,    "0" ,    "0" ,  } , 	
// { "0" ,    "0" ,    "1" ,    "0" ,    "0" ,    "1" ,    "1" ,  } , 	
// { "0" ,    "0" ,    "1" ,    "0" ,    "0" ,    "1" ,    "0" ,  } , 	
// { "0" ,    "0" ,    "1" ,    "0" ,    "0" ,    "0" ,    "1" ,  } , 	
// { "0" ,    "0" ,    "1" ,    "0" ,    "0" ,    "0" ,    "0" ,  } , 	
// { "0" ,    "0" ,    "0" ,    "1" ,    "1" ,    "1" ,    "1" ,  } , 	
// { "0" ,    "0" ,    "0" ,    "1" ,    "1" ,    "1" ,    "0" ,  } , 	
// { "0" ,    "0" ,    "0" ,    "1" ,    "1" ,    "0" ,    "1" ,  } , 	
// { "0" ,    "0" ,    "0" ,    "1" ,    "1" ,    "0" ,    "0" ,  } , 	
// { "0" ,    "0" ,    "0" ,    "1" ,    "0" ,    "1" ,    "1" ,  } , 	
// { "0" ,    "0" ,    "0" ,    "1" ,    "0" ,    "1" ,    "0" ,  } , 	
// { "0" ,    "0" ,    "0" ,    "1" ,    "0" ,    "0" ,    "1" ,  } , 	
// { "0" ,    "0" ,    "0" ,    "1" ,    "0" ,    "0" ,    "0" ,  } , 	
// { "0" ,    "0" ,    "0" ,    "0" ,    "1" ,    "1" ,    "1" ,  } , 	
// { "0" ,    "0" ,    "0" ,    "0" ,    "1" ,    "1" ,    "0" ,  } , 	
// { "0" ,    "0" ,    "0" ,    "0" ,    "1" ,    "0" ,    "1" ,  } , 	
// { "0" ,    "0" ,    "0" ,    "0" ,    "1" ,    "0" ,    "0" ,  } , 	
// { "0" ,    "0" ,    "0" ,    "0" ,    "0" ,    "1" ,    "1" ,  } , 	
// { "0" ,    "0" ,    "0" ,    "0" ,    "0" ,    "1" ,    "0" ,  } , 	
// { "0" ,    "0" ,    "0" ,    "0" ,    "0" ,    "0" ,    "1" ,  } , 	
// { "0" ,    "0" ,    "0" ,    "0" ,    "0" ,    "0" ,    "0" ,  } 
// } ;

// return possibilities;
// }


















	
// 	public static void main(String[] args) {
		
// //  **. truth value: 2, sentence symbol: 2 
// // 2004-11-08 [23:55]
		
// 		int nElements = 2;
// 		int nTruthValues = 2;
// 		int limit = (int) Math.pow( nTruthValues, nElements );
		
// 		String[][] possibilities = new String[ limit ][ nElements ];
		
// 		BaseNMatrix matrix = new BaseNMatrix();
// 		possibilities = matrix.getPossibleValues(nTruthValues, nElements);
		
		
// 		System.out.println( "Inside possibilities[][] with two sentence symbols given..."  );
		
// 		for( int i = 0 ; i < limit; i++ ) {
// 			for(int k = 0; k < nElements; k++) {
// 				System.out.print(possibilities[i][k]);
// 			}
// 			System.out.println(  );
// 		}
		
// // Inside possibilities[][] with two sentence symbols given...
// // 00
// // 01
// // 10
// // 11
		
		
// //  **. truth value: 2, sentence symbol: 3
// // 2004-11-08 [23:55]
		
		
// 		System.out.println(  );
// 		System.out.println(  );
		
// 		nElements = 3;
// 		limit =  (int) Math.pow( nTruthValues, nElements );
// 		String[][] possibilities2 = new String[ limit ][ nElements ];
// 		possibilities2 = matrix.getPossibleValues( nTruthValues, nElements );
		
// 		System.out.println( "Inside possibilities[][] with three sentence symbols given..."  );
		
// 		for( int i = 0 ; i < limit; i++ ) {
// 			for(int k = 0; k < nElements; k++) {
// 				System.out.print(possibilities2[i][k]);
// 			}
// 			System.out.println(  );
// 		}
		
// // Inside possibilities[][] with three sentence symbols given...
// // 000
// // 001
// // 010
// // 011
// // 100
// // 101
// // 110
// // 111
		
// //  **. truth value: 3, sentence symbol: 3
// // 2004-11-08 [23:55]
		
// 		System.out.println(  );
// 		System.out.println(  );
		
// 		nElements = 3;
// 		nTruthValues = 3;
// 		limit =  (int) Math.pow( nTruthValues, nElements );
// 		String[][] possibilities3 = new String[ limit ][ nElements ];
// 		possibilities3 = matrix.getPossibleValues( nTruthValues, nElements );
		
// 		System.out.println( "Inside possibilities[][] with three sentence symbols and with three truth values given..."  );
		
// 		for( int i = 0 ; i < limit; i++ ) {
// 			for(int k = 0; k < nElements; k++) {
// 				System.out.print(possibilities3[i][k]);
// 			}
// 			System.out.println(  );
// 		}
		
// // Inside possibilities[][] with three sentence symbols and with three truth values given...
// // 000
// // 001
// // 002
// // 010
// // 011
// // 012
// // 020
// // 021
// // 022
// // 100
// // 101
// // 102
// // 110
// // 111
// // 112
// // 120
// // 121
// // 122
// // 200
// // 201
// // 202
// // 210
// // 211
// // 212
// // 220
// // 221
// // 222
		
		
// //  **. truth value: 5, sentence symbol: 4
// // 2004-11-08 [23:55]
		
// 		System.out.println(  );
// 		System.out.println(  );
		
// 		nElements = 4;
// 		nTruthValues = 5;
// 		limit =  (int) Math.pow( nTruthValues, nElements );
// 		String[][] possibilities4 = new String[ limit ][ nElements ];
// 		possibilities4 = matrix.getPossibleValues( nTruthValues, nElements );
		
// 		System.out.println( "Inside possibilities[][] with three sentence symbols and with three truth values given..."  );
		
// 		for( int i = 0 ; i < limit; i++ ) {
// 			for(int k = 0; k < nElements; k++) {
// 				System.out.print(possibilities4[i][k]);
// 			}
// 			System.out.println(  );
// 		}
		
		
// 		java.math.BigInteger bi1 = new java.math.BigInteger( "1" );
// 		System.out.println( bi1.toString() );
		
		
		
// 	} // end of main()
	
	
	
// }		// end of class `BaseNMatrix'



// 2004-11-11 [08:37]
// //  *. Old version 

// public class BaseNMatrix {
// // 	public static final boolean DEBUG = true;
// 	private int nElements;
// 	private String bin_string;
// 	private int bin_string_length;
// 	private int limit;
// 	private String[][] elements;
// 	private int a;

// // 2004-11-11 [07:49]
// //  **. getPossibleValues 

// 	public String[][] getPossibleValues(int nTruthValues /* radix */, int size) {

// 		/* presupposition: nElements > 0 */
// 		if(size <= 0) {
// 			System.out.println("BaseNMatrix.class:getPossibleValues() : size must be bigger than 0." );
// 			System.out.println( "Returning null..."  );
// 			return null;
// 		} else nElements = size;

// 		limit = (int) Math.pow( nTruthValues, nElements );
// 		elements = new String[limit][nElements];

// 		a = 0x0;


// 		for(int i = 0; i < limit; i++) {

// // bsh % print( Integer.toString( 5, 2 ) ); 
// // 101
// // bsh % print( Integer.toString( 5, 3 ) ); 
// // 12
// 			bin_string = Integer.toString( a, nTruthValues );
// 			bin_string_length = bin_string.length();

// 			for(int j = nElements; j > 0; j--) {
// 				int index = nElements - j;
// 				if ( (bin_string_length - j) < 0 ) {
// 					elements[i][index] = "0";
// 				}
// 				else {
// 					/* !!! */
// 					elements[i][index] =
// 						bin_string.substring( bin_string_length - j, bin_string_length - j + 1);
// 				}
// 			}

// // 			/* If you want to see what this function does, set DEBUG to true. */
// // 			if(DEBUG) {
// // 				System.out.println("Original: " + bin_string);
// // 				System.out.print("Converted: " );
// // 				for(int k = 0; k < nElements; k++) {
// // 					System.out.print(elements[i][k]);
// // 				}
// // 				System.out.println();
// // 				System.out.println();
// // 			}

// 			a += 0x1;
// 		}


// 		return elements;
// 	}

// 	public static void main(String[] args) {

// //  **. truth value: 2, sentence symbol: 2 
// // 2004-11-08 [23:55]

// 		int nElements = 2;
// 		int nTruthValues = 2;
// 		int limit = (int) Math.pow( nTruthValues, nElements );

// 		String[][] possibilities = new String[ limit ][ nElements ];

// 		BaseNMatrix matrix = new BaseNMatrix();
// 		possibilities = matrix.getPossibleValues(nTruthValues, nElements);

// 		System.out.println( "Inside possibilities[][] with two sentence symbols given..."  );

// 		for( int i = 0 ; i < limit; i++ ) {
// 			for(int k = 0; k < nElements; k++) {
// 				System.out.print(possibilities[i][k]);
// 			}
// 			System.out.println(  );
// 		}

// // Inside possibilities[][] with two sentence symbols given...
// // 00
// // 01
// // 10
// // 11


// //  **. truth value: 2, sentence symbol: 3
// // 2004-11-08 [23:55]


// 		System.out.println(  );
// 		System.out.println(  );

// 		nElements = 3;
// 		limit =  (int) Math.pow( nTruthValues, nElements );
// 		String[][] possibilities2 = new String[ limit ][ nElements ];
// 		possibilities2 = matrix.getPossibleValues( nTruthValues, nElements );

// 		System.out.println( "Inside possibilities[][] with three sentence symbols given..."  );

// 		for( int i = 0 ; i < limit; i++ ) {
// 			for(int k = 0; k < nElements; k++) {
// 				System.out.print(possibilities2[i][k]);
// 			}
// 			System.out.println(  );
// 		}

// // Inside possibilities[][] with three sentence symbols given...
// // 000
// // 001
// // 010
// // 011
// // 100
// // 101
// // 110
// // 111

// //  **. truth value: 3, sentence symbol: 3
// // 2004-11-08 [23:55]

// 		System.out.println(  );
// 		System.out.println(  );

// 		nElements = 3;
// 		nTruthValues = 3;
// 		limit =  (int) Math.pow( nTruthValues, nElements );
// 		String[][] possibilities3 = new String[ limit ][ nElements ];
// 		possibilities3 = matrix.getPossibleValues( nTruthValues, nElements );

// 		System.out.println( "Inside possibilities[][] with three sentence symbols and with three truth values given..."  );

// 		for( int i = 0 ; i < limit; i++ ) {
// 			for(int k = 0; k < nElements; k++) {
// 				System.out.print(possibilities3[i][k]);
// 			}
// 			System.out.println(  );
// 		}

// // Inside possibilities[][] with three sentence symbols and with three truth values given...
// // 000
// // 001
// // 002
// // 010
// // 011
// // 012
// // 020
// // 021
// // 022
// // 100
// // 101
// // 102
// // 110
// // 111
// // 112
// // 120
// // 121
// // 122
// // 200
// // 201
// // 202
// // 210
// // 211
// // 212
// // 220
// // 221
// // 222


// //  **. truth value: 5, sentence symbol: 4
// // 2004-11-08 [23:55]

// 		System.out.println(  );
// 		System.out.println(  );

// 		nElements = 4;
// 		nTruthValues = 5;
// 		limit =  (int) Math.pow( nTruthValues, nElements );
// 		String[][] possibilities4 = new String[ limit ][ nElements ];
// 		possibilities4 = matrix.getPossibleValues( nTruthValues, nElements );

// 		System.out.println( "Inside possibilities[][] with three sentence symbols and with three truth values given..."  );

// 		for( int i = 0 ; i < limit; i++ ) {
// 			for(int k = 0; k < nElements; k++) {
// 				System.out.print(possibilities4[i][k]);
// 			}
// 			System.out.println(  );
// 		}


// // 		java.math.BigInteger bi1 = new java.math.BigInteger( "1" );
// // 		System.out.println( bi1.toString() );



// 	} // end of main()

// }		// end of class `BaseNMatrix'


